diff --git a/test-display.c b/test-display.c
index 3391188..3c6df24 100644
--- a/test-display.c
+++ b/test-display.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
  * test-display: 
  *
@@ -17,172 +18,499 @@
  */
 
 #include "config.h"
-#include "rsvg.h"
-#include "rsvg-cairo.h"
 #include "rsvg-private.h"
+#include "rsvg-size-callback.h"
 
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include <locale.h>
+#include <errno.h>
+#include <math.h>
 
 #include <gtk/gtk.h>
 #include <gdk/gdk.h>
 #include <gdk/gdkkeysyms.h>
 
-#ifdef HAVE_BASENAME
-#include <libgen.h>
+#include "rsvg-compat.h"
+
+#if 0 // defined (G_OS_UNIX)
+#include <gio/gunixinputstream.h>
 #endif
 
-#ifdef ENABLE_XEMBED
-#include <gdk/gdkx.h>
-#endif                          /* ENABLE_XEMBED */
+/* RGBA color parsing
+ *
+ * For pragmatic reasons (i.e. I'm lazy), the following code is copied over from
+ * GDK in GTK+ 3.x.  In GDK2 we don't have support for RGBA colors, so we do
+ * rendering of those by hand here.
+ */
 
-#define DEFAULT_WIDTH  640
-#define DEFAULT_HEIGHT 480
+typedef struct
+{
+  gdouble red;
+  gdouble green;
+  gdouble blue;
+  gdouble alpha;
+} MyGdkRGBA;
 
-static char *
-_rsvg_basename (const char *file)
+#define SKIP_WHITESPACES(s) while (*(s) == ' ') (s)++;
+
+/* Parses a single color component from a rgb() or rgba() specification
+ * according to CSS3 rules. Compared to exact CSS3 parsing we are liberal
+ * in what we accept as follows:
+ *
+ *  - For non-percentage values, we accept floats in the range 0-255
+ *    not just [0-9]+ integers
+ *  - For percentage values we accept any float, not just
+ *     [ 0-9]+ | [0-9]* “.” [0-9]+
+ *  - We accept mixed percentages and non-percentages in a single
+ *    rgb() or rgba() specification.
+ */
+static gboolean
+parse_rgb_value (const gchar  *str,
+                 gchar       **endp,
+                 gdouble      *number)
 {
-#ifdef HAVE_BASENAME
-    if (file && *file) {
-        char *file_dup = g_strdup (file);
-        return basename (file_dup);
+  const char *p;
+
+  *number = g_ascii_strtod (str, endp);
+  if (errno == ERANGE || *endp == str ||
+      isinf (*number) || isnan (*number))
+    return FALSE;
+
+  p = *endp;
+
+  SKIP_WHITESPACES (p);
+
+  if (*p == '%')
+    {
+      *endp = (char *)(p + 1);
+      *number = CLAMP(*number / 100., 0., 1.);
+    }
+  else
+    {
+      *number = CLAMP(*number / 255., 0., 1.);
     }
-#endif
 
-    return NULL;
+  return TRUE;
 }
 
-static GdkPixbuf *
-pixbuf_from_data_with_size_data (const guchar * buff,
-                                 size_t len,
-                                 struct RsvgSizeCallbackData *data,
-                                 const char *base_uri,
-                                 const char *id,
-                                 GError ** error)
+/**
+ * my_gdk_rgba_parse:
+ * @rgba: the #GdkRGBA to fill in
+ * @spec: the string specifying the color
+ *
+ * Parses a textual representation of a color, filling in
+ * the @red, @green, @blue and @alpha fields of the @rgba #GdkRGBA.
+ *
+ * The string can be either one of:
+ * - A standard name (Taken from the X11 rgb.txt file).
+ * - A hexadecimal value in the form “\#rgb”, “\#rrggbb”,
+ *   “\#rrrgggbbb” or ”\#rrrrggggbbbb”
+ * - A RGB color in the form “rgb(r,g,b)” (In this case the color will
+ *   have full opacity)
+ * - A RGBA color in the form “rgba(r,g,b,a)”
+ *
+ * Where “r”, “g”, “b” and “a” are respectively the red, green, blue and
+ * alpha color values. In the last two cases, r g and b are either integers
+ * in the range 0 to 255 or precentage values in the range 0% to 100%, and
+ * a is a floating point value in the range 0 to 1.
+ *
+ * Returns: %TRUE if the parsing succeeded
+ *
+ * Since: 3.0
+ */
+static gboolean
+my_gdk_rgba_parse (MyGdkRGBA   *rgba,
+				   const gchar *spec)
 {
-    RsvgHandle *handle;
-    GdkPixbuf *retval;
+  gboolean has_alpha;
+  gdouble r, g, b, a;
+  gchar *str = (gchar *) spec;
+  gchar *p;
 
-    handle = rsvg_handle_new ();
+  g_return_val_if_fail (spec != NULL, FALSE);
 
-    if (!handle) {
-        g_set_error (error, rsvg_error_quark (), 0, _("Error creating SVG reader"));
-        return NULL;
+
+  if (strncmp (str, "rgba", 4) == 0)
+    {
+      has_alpha = TRUE;
+      str += 4;
+    }
+  else if (strncmp (str, "rgb", 3) == 0)
+    {
+      has_alpha = FALSE;
+      a = 1;
+      str += 3;
+    }
+  else
+    {
+      PangoColor pango_color;
+
+      /* Resort on PangoColor for rgb.txt color
+       * map and '#' prefixed colors
+       */
+      if (pango_color_parse (&pango_color, str))
+        {
+          if (rgba)
+            {
+              rgba->red = pango_color.red / 65535.;
+              rgba->green = pango_color.green / 65535.;
+              rgba->blue = pango_color.blue / 65535.;
+              rgba->alpha = 1;
+            }
+
+          return TRUE;
+        }
+      else
+        return FALSE;
     }
 
-    rsvg_handle_set_size_callback (handle, _rsvg_size_callback, data, NULL);
-    rsvg_handle_set_base_uri (handle, base_uri);
+  SKIP_WHITESPACES (str);
 
-    if (!rsvg_handle_write (handle, buff, len, error)) {
-        g_object_unref (G_OBJECT (handle));
-        return NULL;
+  if (*str != '(')
+    return FALSE;
+
+  str++;
+
+  /* Parse red */
+  SKIP_WHITESPACES (str);
+  if (!parse_rgb_value (str, &str, &r))
+    return FALSE;
+  SKIP_WHITESPACES (str);
+
+  if (*str != ',')
+    return FALSE;
+
+  str++;
+
+  /* Parse green */
+  SKIP_WHITESPACES (str);
+  if (!parse_rgb_value (str, &str, &g))
+    return FALSE;
+  SKIP_WHITESPACES (str);
+
+  if (*str != ',')
+    return FALSE;
+
+  str++;
+
+  /* Parse blue */
+  SKIP_WHITESPACES (str);
+  if (!parse_rgb_value (str, &str, &b))
+    return FALSE;
+  SKIP_WHITESPACES (str);
+
+  if (has_alpha)
+    {
+      if (*str != ',')
+        return FALSE;
+
+      str++;
+
+      SKIP_WHITESPACES (str);
+      a = g_ascii_strtod (str, &p);
+      if (errno == ERANGE || p == str ||
+          isinf (a) || isnan (a))
+        return FALSE;
+      str = p;
+      SKIP_WHITESPACES (str);
     }
 
-    if (!rsvg_handle_close (handle, error)) {
-        g_object_unref (G_OBJECT (handle));
-        return NULL;
+  if (*str != ')')
+    return FALSE;
+
+  str++;
+
+  SKIP_WHITESPACES (str);
+
+  if (*str != '\0')
+    return FALSE;
+
+  if (rgba)
+    {
+      rgba->red = CLAMP (r, 0, 1);
+      rgba->green = CLAMP (g, 0, 1);
+      rgba->blue = CLAMP (b, 0, 1);
+      rgba->alpha = CLAMP (a, 0, 1);
     }
 
-    retval = rsvg_handle_get_pixbuf_sub (handle, id);
-    g_object_unref (G_OBJECT (handle));
+  return TRUE;
+}
+
+#undef SKIP_WHITESPACES
 
-    return retval;
+/* RsvgImage */
+
+#define RSVG_TYPE_IMAGE (rsvg_image_get_type ())
+#define RSVG_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RSVG_TYPE_IMAGE, RsvgImage))
+
+typedef struct _RsvgImage       RsvgImage;
+typedef struct _RsvgImageClass  RsvgImageClass;
+
+struct _RsvgImage {
+    GtkWidget parent_instance;
+
+    cairo_surface_t *surface; /* a cairo image surface */
+	MyGdkRGBA bg_color;
+};
+
+struct _RsvgImageClass {
+    GtkWidgetClass parent_class;
+};
+
+static GType rsvg_image_get_type (void);
+
+static void
+rsvg_image_take_surface (RsvgImage *image,
+                         cairo_surface_t *surface)
+{
+    if (image->surface == surface)
+      return;
+    if (image->surface)
+      cairo_surface_destroy (image->surface);
+    image->surface = surface; /* adopted */
+
+    gtk_widget_queue_resize (GTK_WIDGET (image));
+}
+
+static void
+rsvg_image_set_bg_color (RsvgImage *image,
+						 MyGdkRGBA  color)
+{
+	image->bg_color = color;
+
+	gtk_widget_queue_draw (GTK_WIDGET (image));
+}
+
+G_DEFINE_TYPE (RsvgImage, rsvg_image, GTK_TYPE_WIDGET);
+
+static void
+rsvg_image_init (RsvgImage *image)
+{
+  gtk_widget_set_has_window (GTK_WIDGET (image), FALSE);
+  image->bg_color.red	= 1.0;
+  image->bg_color.green = 1.0;
+  image->bg_color.blue	= 1.0;
+  image->bg_color.alpha = 1.0;
+}
+
+static void
+rsvg_image_finalize (GObject *object)
+{
+  RsvgImage *image = RSVG_IMAGE (object);
+
+  rsvg_image_take_surface (image, NULL);
+}
+
+static void
+rsvg_image_size_request (GtkWidget      *widget,
+						 GtkRequisition *requisition)
+{
+	RsvgImage *image = RSVG_IMAGE (widget);
+
+	if (image->surface) {
+		requisition->width  = cairo_image_surface_get_width (image->surface);
+		requisition->height = cairo_image_surface_get_height (image->surface);
+	} else {
+		requisition->width  = 1;
+		requisition->height = 1;
+	}
+}
+
+static gboolean
+rsvg_image_expose_event (GtkWidget *widget,
+						 GdkEventExpose *event)
+{
+	RsvgImage *image = RSVG_IMAGE (widget);
+	cairo_surface_t *surf;
+	cairo_t *surf_cr;
+	cairo_t *gdk_cr;
+	int width, height;
+
+	if (image->surface == NULL)
+		return FALSE;
+
+	width  = cairo_image_surface_get_width (image->surface);
+	height = cairo_image_surface_get_height (image->surface);
+
+	surf = cairo_image_surface_create (CAIRO_FORMAT_RGB24, width, height);
+	if (!surf)
+		return FALSE;
+
+	surf_cr = cairo_create (surf);
+	cairo_set_source_rgb (surf_cr,
+						  image->bg_color.red,
+						  image->bg_color.green,
+						  image->bg_color.blue); /* we drop alpha! */
+	cairo_paint (surf_cr);
+
+	cairo_set_source_surface (surf_cr, image->surface, 0.0, 0.0);
+	cairo_paint (surf_cr);
+	cairo_destroy (surf_cr);
+
+	gdk_cr = gdk_cairo_create (widget->window);
+	cairo_set_source_surface (gdk_cr, surf, 0, 0);
+	cairo_paint (gdk_cr);
+	cairo_destroy (gdk_cr);
+
+	cairo_surface_destroy (surf);
+
+	return TRUE;
+}
+
+static void
+rsvg_image_class_init (RsvgImageClass *klass)
+{
+	GObjectClass *gobject_class = G_OBJECT_CLASS (klass);
+	GtkWidgetClass *widget_class = GTK_WIDGET_CLASS (klass);
+
+	gobject_class->finalize = rsvg_image_finalize;
+	widget_class->size_request = rsvg_image_size_request;
+	widget_class->expose_event = rsvg_image_expose_event;
+}
+
+static RsvgImage *
+rsvg_image_new_take_surface (cairo_surface_t *surface)
+{
+  RsvgImage *image;
+
+  image = g_object_new (RSVG_TYPE_IMAGE, NULL);
+  rsvg_image_take_surface (image, surface);
+
+  return image;
+}
+
+static cairo_surface_t *
+rsvg_image_get_surface (RsvgImage *image)
+{
+  return image->surface;
+}
+
+/* Main */
+
+static char *
+_rsvg_basename (const char *file)
+{
+    if (file && *file)
+        return g_path_get_basename (file);
+
+    return NULL;
 }
 
 typedef struct _ViewerCbInfo ViewerCbInfo;
 struct _ViewerCbInfo {
     GtkWidget *window;
     GtkWidget *popup_menu;
-    GtkWidget *image;           /* the image widget */
-
-    GdkPixbuf *pixbuf;
-    GByteArray *svg_bytes;
+    RsvgImage *image;
+    RsvgHandle *handle;
     GtkAccelGroup *accel_group;
     char *base_uri;
     char *id;
+    RsvgDimensionData dimensions;
+    gdouble x_zoom;
+    gdouble y_zoom;
 };
 
-static void
-zoom_image (ViewerCbInfo * info, gint width, gint height)
+static cairo_surface_t *
+render_to_surface (ViewerCbInfo *info)
 {
-    struct RsvgSizeCallbackData size_data;
-    GdkPixbuf *save_pixbuf = info->pixbuf;
+    int width, height;
+    cairo_matrix_t matrix;
+    cairo_surface_t *surface;
+    cairo_t *cr;
 
-    size_data.type = RSVG_SIZE_WH;
-    size_data.width = width;
-    size_data.height = height;
-    size_data.keep_aspect_ratio = FALSE;
+    width = ceil ((double) info->dimensions.width * info->x_zoom);
+    height = ceil ((double) info->dimensions.height * info->y_zoom);
 
-    info->pixbuf =
-        pixbuf_from_data_with_size_data (info->svg_bytes->data, info->svg_bytes->len,
-                                         &size_data, info->base_uri, info->id, NULL);
-    gtk_image_set_from_pixbuf (GTK_IMAGE (info->image), info->pixbuf);
+    surface = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
+    if (cairo_surface_status (surface) != CAIRO_STATUS_SUCCESS) {
+        cairo_surface_destroy (surface);
+        return NULL;
+    }
 
-    if (save_pixbuf)
-        g_object_unref (G_OBJECT (save_pixbuf));
-}
+    cr = cairo_create (surface);
 
-static void
-zoom_in (GObject * ignored, ViewerCbInfo * info)
-{
-    if (!info->pixbuf)
-        return;
-    zoom_image (info, gdk_pixbuf_get_width (info->pixbuf) * 1.25,
-                gdk_pixbuf_get_height (info->pixbuf) * 1.25);
+    cairo_matrix_init_scale (&matrix, info->x_zoom, info->y_zoom);
+    cairo_transform (cr, &matrix);
+
+    if (!rsvg_handle_render_cairo_sub (info->handle, cr, info->id)) {
+        cairo_destroy (cr);
+        cairo_surface_destroy (surface);
+        return NULL;
+    }
+
+    cairo_destroy (cr);
+
+    if (cairo_surface_status (surface) != CAIRO_STATUS_SUCCESS) {
+        g_printerr ("Error while rendering image: %d\n", cairo_surface_status (surface));
+        cairo_surface_destroy (surface);
+        return NULL;
+    }
+
+    return surface;
 }
 
 static void
-zoom_out (GObject * ignored, ViewerCbInfo * info)
+set_window_title (ViewerCbInfo * info)
 {
-    if (!info->pixbuf)
-        return;
-    zoom_image (info, gdk_pixbuf_get_width (info->pixbuf) / 1.25,
-                gdk_pixbuf_get_height (info->pixbuf) / 1.25);
+    char *title;
+    gchar *zoom_string;
+
+    if (info->x_zoom != info->y_zoom) {
+        zoom_string = g_strdup_printf ("%4d%% : %4d%%",
+                                       (gint) (info->x_zoom * 100),
+                                       (gint) (info->y_zoom * 100));
+    } else {
+        zoom_string = g_strdup_printf ("%4d%%",
+                                       (gint) (info->x_zoom * 100));
+    }
+
+    if (info->id) {
+        title = g_strdup_printf ("%s#%s (%s) — %s",
+                                 info->base_uri, info->id,
+                                 zoom_string,
+                                 _("SVG Viewer"));
+    } else {
+        title = g_strdup_printf ("%s (%s) — %s",
+                                 info->base_uri,
+                                 zoom_string,
+                                 _("SVG Viewer"));
+    }
+    gtk_window_set_title (GTK_WINDOW (info->window), title);
+    g_free (title);
+    g_free (zoom_string);
 }
 
 static void
-rsvg_window_set_default_icon (GtkWindow * window, GdkPixbuf * src)
+zoom_image (ViewerCbInfo * info, gdouble factor)
 {
-    GList *list;
-    GdkPixbuf *icon;
-    gint width, height;
-
-    width = gdk_pixbuf_get_width (src);
-    height = gdk_pixbuf_get_height (src);
-
-    if (width > 128 || height > 128) {
-        /* sending images greater than 128x128 has this nasty tendency to 
-           cause broken pipe errors X11 Servers */
-        if (width > height) {
-            width = 0.5 + width * 128. / height;
-            height = 128;
-        } else {
-            height = 0.5 + height * 128. / width;
-            width = 128;
-        }
+    info->x_zoom *= factor;
+    info->y_zoom *= factor;
 
-        icon = gdk_pixbuf_scale_simple (src, width, height, GDK_INTERP_BILINEAR);
-    } else {
-        icon = g_object_ref (G_OBJECT (src));
-    }
+    rsvg_image_take_surface (info->image, render_to_surface (info));
 
-    list = g_list_prepend (NULL, icon);
-    gtk_window_set_icon_list (window, list);
-    g_list_free (list);
+    set_window_title (info);
+}
 
-    g_object_unref (G_OBJECT (icon));
+static void
+zoom_in (GObject * ignored, ViewerCbInfo * info)
+{
+    zoom_image (info, sqrt (G_SQRT2));
 }
 
-#if GTK_CHECK_VERSION(2,10,0)
+static void
+zoom_out (GObject * ignored, ViewerCbInfo * info)
+{
+    zoom_image (info, 1. / sqrt (G_SQRT2));
+}
 
 static void
 begin_print (GtkPrintOperation *operation,
 			 GtkPrintContext   *context,
 			 gpointer           user_data)
 {
-	gtk_print_operation_set_n_pages(operation, 1);
+	gtk_print_operation_set_n_pages (operation, 1);
 }
 
 static void
@@ -192,55 +520,46 @@ draw_page (GtkPrintOperation *operation,
 		   gpointer           user_data)
 {
     ViewerCbInfo *info = (ViewerCbInfo *) user_data;
+    cairo_t *cr;
+    gdouble page_width, page_height, page_aspect;
+    gdouble width, height, aspect;
+    cairo_matrix_t matrix;
+
+    cr = gtk_print_context_get_cairo_context (context);
+    page_width = gtk_print_context_get_width (context);
+    page_height = gtk_print_context_get_height (context);
+    page_aspect = page_width / page_height;
+
+    // FIXMEchpe
+    rsvg_handle_set_dpi_x_y (info->handle, 
+                             gtk_print_context_get_dpi_x(context), 
+                             gtk_print_context_get_dpi_y(context));
+
+    width = info->dimensions.width;
+    height = info->dimensions.height;
+    aspect = width / height;
+
+    if (aspect <= page_aspect) {
+        width = page_height * aspect;
+        height = page_height;
+    } else {
+        width = page_width;
+        height = page_width / aspect;
+    }
 
-	cairo_t *cr;
-	gdouble page_width, page_height;
-  
-	cr = gtk_print_context_get_cairo_context (context);
-	page_width = gtk_print_context_get_width (context);
-	page_height = gtk_print_context_get_height (context);
-
-	{
-		RsvgHandle *handle;
-		RsvgDimensionData svg_dimensions;
-		struct RsvgSizeCallbackData size_data;
-
-		/* should not fail */
-		handle = rsvg_handle_new_from_data(info->svg_bytes->data, info->svg_bytes->len, NULL);
-		rsvg_handle_set_base_uri (handle, info->base_uri);
-		rsvg_handle_set_dpi_x_y (handle, gtk_print_context_get_dpi_x(context), 
-								 gtk_print_context_get_dpi_y(context));
-		rsvg_handle_get_dimensions(handle, &svg_dimensions);
-
-        if (svg_dimensions.width > page_width || svg_dimensions.height > page_height) {
-            /* scale down the image to the page's size, while preserving the aspect ratio */
-
-            if ((double) svg_dimensions.height * (double) page_width > (double) svg_dimensions.width * (double) page_height) {
-                svg_dimensions.width = 0.5 + (double) svg_dimensions.width *(double) page_height / (double) svg_dimensions.height;
-                svg_dimensions.height = page_height;
-            } else {
-                svg_dimensions.height = 0.5 + (double) svg_dimensions.height *(double) page_width / (double) svg_dimensions.width;
-                svg_dimensions.width = page_width;
-            }
-        }
-
-		size_data.type = RSVG_SIZE_WH;
-		size_data.width = svg_dimensions.width;
-		size_data.height = svg_dimensions.height;
-		size_data.keep_aspect_ratio = FALSE;
-		rsvg_handle_set_size_callback (handle, _rsvg_size_callback, &size_data, NULL);
-
-		rsvg_handle_render_cairo(handle, cr);
-
-		g_object_unref (handle);
-	}
+    cairo_save (cr);
+    cairo_matrix_init_scale (&matrix, 
+                             width / info->dimensions.width,
+                             height / info->dimensions.height);
+    cairo_transform (cr, &matrix);
+    rsvg_handle_render_cairo (info->handle, cr);
+    cairo_restore (cr);
 }
 
 static void
 print_pixbuf (GObject * ignored, gpointer user_data)
 {
   GtkPrintOperation *print;
-  GtkPrintOperationResult res;
   ViewerCbInfo *info = (ViewerCbInfo *) user_data;
 
   print = gtk_print_operation_new ();
@@ -248,14 +567,12 @@ print_pixbuf (GObject * ignored, gpointer user_data)
   g_signal_connect (print, "begin_print", G_CALLBACK (begin_print), info);
   g_signal_connect (print, "draw_page", G_CALLBACK (draw_page), info);
 
-  res = gtk_print_operation_run (print, GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG,
+  (void)gtk_print_operation_run (print, GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG,
                                  GTK_WINDOW (info->window), NULL);
 
   g_object_unref (print);
 }
 
-#endif                          /* HAVE_GNOME_PRINT */
-
 static char *
 save_file (const char *title, const char *suggested_filename, GtkWidget * parent, int *success)
 {
@@ -266,8 +583,8 @@ save_file (const char *title, const char *suggested_filename, GtkWidget * parent
     dialog = gtk_file_chooser_dialog_new (title,
                                           GTK_WINDOW (parent),
                                           GTK_FILE_CHOOSER_ACTION_SAVE,
-                                          GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
-                                          GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT, NULL);
+                                          _("_Cancel"), GTK_RESPONSE_CANCEL,
+                                          _("_Save"), GTK_RESPONSE_ACCEPT, NULL);
 
     if (suggested_filename && *suggested_filename) {
         gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (dialog), suggested_filename);
@@ -289,6 +606,7 @@ save_pixbuf (GObject * ignored, gpointer user_data)
     ViewerCbInfo *info = (ViewerCbInfo *) user_data;
     char *filename, *base_name, *filename_suggestion;
     int success = 0;
+    cairo_surface_t *surface;
 
     base_name = _rsvg_basename (info->base_uri);
     if (base_name)
@@ -301,92 +619,18 @@ save_pixbuf (GObject * ignored, gpointer user_data)
     g_free (filename_suggestion);
 
     if (filename) {
-        GError *err = NULL;
-
-        if (!gdk_pixbuf_save (info->pixbuf, filename, "png", &err, NULL)) {
-            if (err) {
+        surface = rsvg_image_get_surface (info->image);
+        if (cairo_surface_write_to_png (surface, filename) != CAIRO_STATUS_SUCCESS) {
                 GtkWidget *errmsg;
 
                 errmsg = gtk_message_dialog_new (GTK_WINDOW (info->window),
                                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                                  GTK_MESSAGE_WARNING,
-                                                 GTK_BUTTONS_CLOSE, "%s", err->message);
+                                                 GTK_BUTTONS_CLOSE, "Failed to save");
 
                 gtk_dialog_run (GTK_DIALOG (errmsg));
 
-                g_error_free (err);
                 gtk_widget_destroy (errmsg);
-            }
-        }
-
-        g_free (filename);
-    } else if (success) {
-        GtkWidget *errmsg;
-
-        errmsg = gtk_message_dialog_new (GTK_WINDOW (info->window),
-                                         GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
-                                         GTK_MESSAGE_WARNING,
-                                         GTK_BUTTONS_CLOSE, _("No filename given"));
-        gtk_window_set_transient_for (GTK_WINDOW (errmsg), GTK_WINDOW (info->window));
-
-        gtk_dialog_run (GTK_DIALOG (errmsg));
-        gtk_widget_destroy (errmsg);
-    }
-}
-
-static void
-save_svg (GObject * ignored, gpointer user_data)
-{
-    ViewerCbInfo *info = (ViewerCbInfo *) user_data;
-    char *filename, *base_name;
-    int success = 0;
-
-    base_name = _rsvg_basename (info->base_uri);
-    filename = save_file (_("Save SVG"), base_name, info->window, &success);
-    g_free (base_name);
-
-    if (filename) {
-        FILE *fp;
-
-        /* todo: make this support gnome vfs */
-        fp = fopen (filename, "wb");
-        if (!fp) {
-            GtkWidget *errmsg;
-
-            errmsg = gtk_message_dialog_new (GTK_WINDOW (info->window),
-                                             GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
-                                             GTK_MESSAGE_WARNING,
-                                             GTK_BUTTONS_CLOSE, _("Couldn't save %s"), filename);
-            gtk_window_set_transient_for (GTK_WINDOW (errmsg), GTK_WINDOW (info->window));
-
-            gtk_dialog_run (GTK_DIALOG (errmsg));
-            gtk_widget_destroy (errmsg);
-        } else {
-            size_t written = 0, remaining = info->svg_bytes->len;
-            const unsigned char *buffer = info->svg_bytes->data;
-
-            while (remaining > 0) {
-                written = fwrite (buffer + (info->svg_bytes->len - remaining), 1, remaining, fp);
-                if ((written < remaining) && ferror (fp) != 0) {
-                    GtkWidget *errmsg;
-
-                    errmsg = gtk_message_dialog_new (GTK_WINDOW (info->window),
-                                                     GTK_DIALOG_MODAL |
-                                                     GTK_DIALOG_DESTROY_WITH_PARENT,
-                                                     GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE,
-                                                     _("Couldn't save %s"), filename);
-                    gtk_window_set_transient_for (GTK_WINDOW (errmsg), GTK_WINDOW (info->window));
-
-                    gtk_dialog_run (GTK_DIALOG (errmsg));
-                    gtk_widget_destroy (errmsg);
-
-                    break;
-                }
-
-                remaining -= written;
-            }
-
-            fclose (fp);
         }
 
         g_free (filename);
@@ -421,16 +665,12 @@ create_popup_menu (ViewerCbInfo * info)
 {
     GtkWidget *popup_menu;
     GtkWidget *menu_item;
-    GtkWidget *stock;
 
     popup_menu = gtk_menu_new ();
     gtk_menu_set_accel_group (GTK_MENU (popup_menu), info->accel_group);
 
     if (info->base_uri) {
-        menu_item = gtk_image_menu_item_new_with_label (_("Copy SVG location"));
-        stock = gtk_image_new_from_stock (GTK_STOCK_COPY, GTK_ICON_SIZE_MENU);
-        gtk_widget_show (stock);
-        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_item), stock);
+        menu_item = gtk_menu_item_new_with_label (_("Copy SVG location"));
         g_signal_connect (menu_item, "activate", G_CALLBACK (copy_svg_location), info);
         gtk_widget_show (menu_item);
         gtk_menu_shell_append (GTK_MENU_SHELL (popup_menu), menu_item);
@@ -438,40 +678,28 @@ create_popup_menu (ViewerCbInfo * info)
                                     GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
     }
 
-    menu_item = gtk_image_menu_item_new_from_stock (GTK_STOCK_SAVE, NULL);
-    g_signal_connect (menu_item, "activate", G_CALLBACK (save_svg), info);
-    gtk_widget_show (menu_item);
-    gtk_menu_shell_append (GTK_MENU_SHELL (popup_menu), menu_item);
-    gtk_widget_add_accelerator (menu_item, "activate", info->accel_group, GDK_S, GDK_CONTROL_MASK,
-                                GTK_ACCEL_VISIBLE);
-
-    menu_item = gtk_image_menu_item_new_with_label (_("Save as PNG"));
-    stock = gtk_image_new_from_stock (GTK_STOCK_SAVE_AS, GTK_ICON_SIZE_MENU);
-    gtk_widget_show (stock);
-    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_item), stock);
+    menu_item = gtk_menu_item_new_with_label (_("Save as PNG"));
     g_signal_connect (menu_item, "activate", G_CALLBACK (save_pixbuf), info);
     gtk_widget_show (menu_item);
     gtk_menu_shell_append (GTK_MENU_SHELL (popup_menu), menu_item);
     gtk_widget_add_accelerator (menu_item, "activate", info->accel_group, GDK_S,
                                 GDK_CONTROL_MASK | GDK_SHIFT_MASK, GTK_ACCEL_VISIBLE);
 
-#if GTK_CHECK_VERSION(2,10,0)
-    menu_item = gtk_image_menu_item_new_from_stock (GTK_STOCK_PRINT, NULL);
+    menu_item = gtk_menu_item_new_with_label (_("Print"));
     g_signal_connect (menu_item, "activate", G_CALLBACK (print_pixbuf), info);
     gtk_widget_show (menu_item);
     gtk_menu_shell_append (GTK_MENU_SHELL (popup_menu), menu_item);
     gtk_widget_add_accelerator (menu_item, "activate", info->accel_group, GDK_P, GDK_CONTROL_MASK,
                                 GTK_ACCEL_VISIBLE);
-#endif
 
-    menu_item = gtk_image_menu_item_new_from_stock (GTK_STOCK_ZOOM_IN, NULL);
+    menu_item = gtk_menu_item_new_with_label (_("Zoom In"));
     g_signal_connect (menu_item, "activate", G_CALLBACK (zoom_in), info);
     gtk_widget_show (menu_item);
     gtk_menu_shell_append (GTK_MENU_SHELL (popup_menu), menu_item);
     gtk_widget_add_accelerator (menu_item, "activate", info->accel_group, GDK_plus,
                                 GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
-
-    menu_item = gtk_image_menu_item_new_from_stock (GTK_STOCK_ZOOM_OUT, NULL);
+                                              
+    menu_item = gtk_menu_item_new_with_label (_("Zoom Out"));
     g_signal_connect (menu_item, "activate", G_CALLBACK (zoom_out), info);
     gtk_widget_show (menu_item);
     gtk_menu_shell_append (GTK_MENU_SHELL (popup_menu), menu_item);
